VERSION 5.00
Object = "{7F5E3516-F816-11D0-B64C-00001C1AD1F8}#6.0#0"; "DWSBC36.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Chat Room Hook Example"
   ClientHeight    =   690
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4350
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   690
   ScaleWidth      =   4350
   StartUpPosition =   3  'Windows Default
   Begin DWSBC36Lib.SubClass sbcMain 
      Left            =   0
      Top             =   0
      Messages        =   "frmMain.frx":000C
      CtlParam        =   ""
      RegMessage1     =   ""
      RegMessage2     =   ""
      RegMessage3     =   ""
      RegMessage4     =   ""
      RegMessage5     =   ""
      Persist         =   0   'False
      Type            =   0
      PostOnFreeze    =   0   'False
      PostOnFreezeMax =   20
      CrossTaskTimeout=   5000
      UseOnlyXEvent   =   0   'False
      UseDirectInterface=   0   'False
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'***********************************************************
'* Form:          frmMain
'* Description:   AOL chat room hook example.
'* Author:        Craig Jasper, Jr.
'* Machine:       CRAIG [ID: CP_4850] | Windows 2000 Server (SP1)
'* Modified:      April 13, 2001
'* Notes:         Written in VB6 Enterprise Edition (Service Pack 5).
'*                Requires SpyWorks 6.2 Subclassing control
'*                (DWSBC36.OCX). Check out http://www.desaware.com
'*                Tested on America Online 5.0 Revision 205.103 only.
'***********************************************************

' Overview: This example shows how to determine if the
' newly created AOL window is an AOL chat room. If it
' is then you can do just about anything you want,
' like hide the chat room window and display your
' form with your own chat room and so fourth.
'
' This example assumes that you have minimal experience
' with subclassing via SpyWorks 6.2 and are running
' plain AOL, meaning not with add-on's like PowerTools
' loaded.

' This example also has lots of room for improvement.

Option Explicit

' The descriptions for WM_DESTROY and WM_MDICREATE
' are from Dan Appleman's Visual Basic Programmers
' Guide to the Win32 API.
Private Const WM_DESTROY = &H2        ' Sent to a window before it is destroyed, but after it has been hidden.
Private Const WM_MDICREATE = &H220    ' This message can be used to create new MDI child windows on an MDI form.

'********************************************************************************
' Routine:        Form_KeyPress
' Description:    Allows Escape key to unload form.
'********************************************************************************
Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyEscape Then
        Unload Me
    End If
End Sub

Private Sub Form_Load()
    On Error GoTo PROC_ERR
    
    With Me
        .AutoRedraw = True    ' Enabled because this example draws on form.
        .KeyPreview = True    ' This is so we can use the Form_KeyPress routine.
        .Move 0, 0
        Call SetTopMostWindow(.hWnd)
    End With
        
    ' Make sure AOL's MDIClient is present before
    ' attempting to subclass it:
    If GetMDIClient Then
        With sbcMain
            .Messages = WM_MDICREATE
            .Messages = WM_DESTROY
            .Type = sbcPostDefault    ' See your SpyWorks help files for more info on sbcPostDefault.
            .HwndParam = GetMDIClient
        End With
    Else
        MsgBox "Please load America Online first.", vbInformation
        Unload Me
    End If
    
    Exit Sub
PROC_ERR:
    MsgBox Err.Description, vbCritical
End Sub

Private Sub Form_Unload(Cancel As Integer)
    On Error GoTo PROC_ERR
    
    ' WARNING: DO NOT OMIT ANY OF THE CODE BELOW IN
    ' THIS ROUTINE AND NEVER USE THE END STATEMENT!
    
    If Not sbcMain.HwndParam = 0 Then
        sbcMain.HwndParam = 0
    End If
    
    Set frmMain = Nothing

    Exit Sub
PROC_ERR:
    MsgBox Err.Description, vbCritical
End Sub

'********************************************************************************
' Routine:        sbcMain_DelayedEvent
' Description:    See your SpyWorks help files for description.
'********************************************************************************
Private Sub sbcMain_DelayedEvent(lvalue As Long)
    On Error GoTo PROC_ERR
   
    ' Since we are using a Posted message we can use
    ' DoEvents without a problem. See your SpyWorks
    ' help files for more information on that subject.
    
    ' Let system catch up:
    DoEvents
    
'//////////////////////////////////////////////////////////////////////
    ' I added this (enclosed in /'s) because I cannot
    ' stand the AOL Plus window. This assumes that the
    ' AOL Plus window is not yet created, like before
    ' you sign on or when you switch screen names. Note
    ' that the caption is actually " AOL PLUS" (and
    ' " AOL Plus" depending on the window state) with
    ' the space before the "A".
    
    ' Convert the caption to upper case so that this
    ' will not be case sensitive:
    If UCase(GetCaption(lvalue)) = (" AOL PLUS") Then
        Call HideWindow(lvalue)
        Me.Cls
        Me.Print "AOL Plus window was hidden at " & Now
    End If
'//////////////////////////////////////////////////////////////////////
    
    ' Give the window some time to create all the
    ' controls before calling IsChatRoom:
    Call SysWait(1100)

    If IsChatRoom Then
        Me.Cls
        Me.Print "Chat room window created at: " & Now
    End If

    Exit Sub
PROC_ERR:
    MsgBox Err.Description, vbCritical
End Sub

'********************************************************************************
' Routine:        sbcMain_WndMessageX
' Description:    See your SpyWorks help files for description.
'********************************************************************************
Private Sub sbcMain_WndMessageX _
       (wnd As Long, _
       msg As Long, _
       wp As Long, _
       lp As Long, _
       retval As Long, _
       nodef As Integer, _
       process As Long)
       
    On Error GoTo PROC_ERR
    
    Select Case msg
        Case WM_DESTROY
            ' Stop subclassing:
            sbcMain.HwndParam = 0
            Me.Cls
            Me.Print "WM_DESTROY message at " & Now
        Case WM_MDICREATE
            ' Post event to the DelayedEvent routine of
            ' SpyWorks 6.2 Subclassing control to process:
            sbcMain.PostEvent = retval    ' retval is the handle created window.
    End Select
    
    Exit Sub
PROC_ERR:
    MsgBox Err.Description, vbCritical
End Sub
